import { Command } from "discord-akairo";
import { Role } from "discord.js";
import { Message } from "discord.js";
import { cancelString } from "../../config/Constants";
import { Guild } from "../../entity/Guild";

import { infoEmbed, successEmbed } from "../Util";

class SetRestrictedRole extends Command {
  constructor() {
    super("setRestrictedRole", {
      category: "Server Settings",
      aliases: ["SetRestrictedRole"],
      description: "<role>",
      clientPermissions: ["CREATE_INSTANT_INVITE", "BAN_MEMBERS"],
      channel: "guild",
      args: [
        {
          id: "newRole",
          type: "role",
          prompt: {
            start: () =>
              infoEmbed("The new role for restricted access:").setFooter(
                cancelString
              ),
          },
        },
      ],
    });
  }

  async exec(message: Message, args: { newRole: Role }) {
    const { newRole } = args;
    const author = message.member;
    if (author === null) {
      return;
    }

    const guild = await Guild.findOneOrFail({
      where: { guild: author.guild.id },
    });
    guild.jailedRole = newRole.id;
    guild.save();

    message.reply(
      successEmbed("Guild Settings Updated")
        .addField("Name", guild.name, true)
        .addField("Post Channel", `<#${guild.channel}>`, true)
        .addField("\u200b", "\u200b", true)
        .addField("Staff Role", `<@&${guild.staffRole}>`, true)
        .addField("Restricted Role", `<@&${guild.jailedRole}>`, true)
        .addField("\u200b", "\u200b", true)
        .addField("Minimum time before re-appeal", guild.defaultExpiry)
    );
  }
}

export default SetRestrictedRole;
