import {Listener} from "discord-akairo";
import {Message} from "discord.js";
import {errorEmbed, statusEmbed} from "../Util";

class MessageCreate extends Listener {
  constructor() {
    super("message", {
      emitter: "client",
      event: "message",
    });
  }

  async exec(message: Message) {
    const author = message.member;
    if (!author) {
      return errorEmbed("This bot can only be used in guilds.");
    }

    if (!message.content.match(`^<@!?${message.client.user.id}>$`)) return;

    const embed = await statusEmbed(message);
    return message.channel.send(embed);
  }
}

export default MessageCreate;
