import base64url from "base64url";
import * as crypto from "crypto";
import { Request, Response } from "express";
import { OAUTH_SCOPE } from "../config/Constants";
import { StateToken } from "../entity/StateToken";
import { respond } from "./Util";

export const genOAuth = async (req: Request, res: Response) => {
  const { api } = req.app.get("config");

  let token: string;
  do {
    token = base64url(crypto.randomBytes(18));
  } while ((await StateToken.count({ where: { token } })) !== 0);

  new StateToken(token).save();

  let url =
    "https://discord.com/api/oauth2/authorize" +
    `?response_type=code` +
    `&prompt=consent` +
    `&client_id=${api.client_id}` +
    `&scope=${encodeURIComponent(OAUTH_SCOPE)}` +
    `&state=${token}` +
    `&redirect_uri=${encodeURIComponent(api.redirect_uri)}`;

  respond(res, { redirectURL: url });
};
