import { getManager } from "typeorm";
import { DiscordCache } from "./DiscordCache";
import { DiscordToken } from "./DiscordToken";
import { StateToken } from "./StateToken";

export const pruneDB = (interval: number) => {
    const manager = getManager();

    setInterval(() => {
        const cleaning = [
            { type: StateToken, name: "state_tokens", col: "expiring" },
            { type: DiscordToken, name: "discord_tokens", col: "expiring" },
            { type: DiscordCache, name: "discord_cache", col: "expiring" }
        ]

        cleaning.forEach(({ type, name, col }) => {
            manager
                .createQueryBuilder()
                .delete()
                .from(type, name)
                .where(`${name}.${col} < datetime(:now)`, { now: new Date().toISOString() })
                .execute()
                .catch(err => {
                    console.error("Error while pruning db: " + err)
                })
        })
    }, interval);
}