import {BaseEntity, Column, Entity, PrimaryColumn} from "typeorm";
import {DiscordToken} from "./DiscordToken";

@Entity({ name: "discord_cache" })
export class DiscordCache extends BaseEntity {
  @PrimaryColumn({ unique: true })
  authToken: string;

  @Column()
  userID: string;

  @Column()
  username: string;

  @Column()
  discriminator: string;

  @Column({nullable: true })
  avatar?: string;

  @Column()
  expiring: Date;

  constructor(
    token: string,
    userID: string,
    name: string,
    discr: string,
    avatar?: string
  ) {
    super();
    this.authToken = token;
    this.userID = userID;
    this.username = name;
    this.discriminator = discr;
    this.avatar = avatar;
    this.expiring = new Date();
    this.expiring.setHours(this.expiring.getHours() + 1)
  }

  json() {
    return {
      id: this.userID,
      username: this.username,
      discriminator: this.discriminator,
      avatar: this.avatar,
    };
  }
}
